// capt.c
#include <inarm.h>
#include <stdio.h>
#include <stdlib.h>
#include "board.h"

CSP_CAPT_T * const CAPT0 = (CSP_CAPT_T *)CAPT0_BASE_ADDRESS;
CSP_CAPT_T * const CAPT1 = (CSP_CAPT_T *)CAPT1_BASE_ADDRESS;

void InitCapt0(void) {

  // Enable clock for CAP
  CAPT0->ECR = CAP;

  // Capture enable
  CAPT0->CR = CAPEN;

  // Divider for capture 0, Measure between positive edge
  CAPT0->MR = CAPT_PRESCALAR(1) + MEASMODE_POS;

  // Capture disable
  CAPT1->CR = CAPDIS;

}

void StarMeasureCapt0(void) {

  // Start capture
  CAPT0->CR = STARTCAPT;
}

unsigned int GetCapt0Value(void) {


  unsigned int val=0;

  // Capture enable
  CAPT0->CR |= CAPEN;

  // Start capture
  CAPT0->CR |= STARTCAPT;

  // while data is captured
  while(((CAPT0->SR&DATACAPT)!=(DATACAPT))&&((CAPT0->SR&OVERFLOW)!=(OVERFLOW)));

  // return value
  val = CAPT0->DR;

  // Capture disable
  CAPT0->CR |= CAPDIS;

  // return
  return val;
}

void InitCapt1(void) {

  // Enable clock for CAP
  CAPT1->ECR = CAP;

  // Capture enable
  CAPT1->CR = CAPEN;

  // Divider for capture 0, Measure between positive edge
  CAPT1->MR = CAPT_PRESCALAR(1) + MEASMODE_POS;

  // Capture disable
  CAPT1->CR = CAPDIS;

}

void StarMeasureCapt1(void) {

  // Start capture
  CAPT1->CR = STARTCAPT;
}

unsigned int GetCapt1Value(void) {

  unsigned int val=0;

  // Capture enable
  CAPT1->CR |= CAPEN;

  // Start capture
  CAPT1->CR |= STARTCAPT;

  // while data is captured
  while(((CAPT1->SR&DATACAPT)!=(DATACAPT))&&((CAPT1->SR&OVERFLOW)!=(OVERFLOW)));

  // return value
  val = CAPT1->DR;

  // Capture disable
  CAPT1->CR |= CAPDIS;

  // return
  return val;
}

